﻿//Copyright Warren Harding 2011-2012.  All rights reserved.
using System;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace Functional
{
    public class Folds
    {
        public static T Fold<T>(T[] inputs, Func<T, T, T> foldFunction)
        {
            Int32 L;
            T lOut = inputs[0];
            for (L = 1; L < inputs.Length; L++)
            {
                lOut = foldFunction(lOut, inputs[L]);
            }
            return lOut;
        }

        public static T2[] FoldToSegments<T1,T2>(T1[] inputs, Func<T1, T1, T2> foldFunction)
        {
            Int32 L;
            List<T2> t2s = new List<T2>();
            T2 segment;
            for (L = 0; L < inputs.Length-1; L++)
            {
                segment = foldFunction(inputs[L], inputs[L+1]);
                t2s.Add(segment);
            }
            return t2s.ToArray();
        }

        public static Boolean AnyTrue(Boolean[] inList)
        {
            if (inList.Length == 0)
            {
                return false;
            }
            Int32 L;
            for (L = 0; L < inList.Length; L++)
            {
                if (inList[L] == true)
                {
                    return true;
                }
            }
            return false;
        }

        public static Boolean AllTrue(Boolean[] inList)
        {
            if (inList.Length == 0)
            {
                return false;
            }
            Int32 L;
            for (L = 0; L < inList.Length; L++)
            {
                if (inList[L] == false)
                {
                    return false;
                }
            }
            return true;
        }

        public static Boolean AnyFalse(Boolean[] inList)
        {
            if (inList.Length == 0)
            {
                return false;
            }
            Int32 L;
            for (L = 0; L < inList.Length; L++)
            {
                if (inList[L] == false)
                {
                    return true;
                }
            }
            return false;
        }

        public static Boolean AllFalse(Boolean[] inList)
        {
            if (inList.Length == 0)
            {
                return false;
            }
            Int32 L;
            for (L = 0; L < inList.Length; L++)
            {
                if (inList[L] == true)
                {
                    return false;
                }
            }
            return true;
        }


    }
}
